/**************************************
 * $Author: kaneda $
 * $Date: 2002/12/27 08:16:06 $
 **************************************/

/* tcp.c */

#include "util.h"


int tcp_connect(const char * host, const char * serv) {
  int			sockfd;
  struct hostent * 	hp;
  struct sockaddr_in 	sin;


  sockfd = Socket(AF_INET, SOCK_STREAM, 0);
  
  Mzero(&sin, sizeof(sin));  
  sin.sin_family = AF_INET;
  sin.sin_port = htons(atoi(serv));

  
  if ((sin.sin_addr.s_addr = inet_addr(host)) == /*(in_addr_t)-1*/ INADDR_NONE) {
    if ((hp = gethostbyname(host)) == NULL) {
      Close(sockfd);
      return -1;
    }
    memcpy(&sin.sin_addr, hp->h_addr, hp->h_length);
  }


  if (connect(sockfd, (struct sockaddr *)&sin, sizeof(sin)) == -1) {
    Close(sockfd);
    return -1;
  }

  return sockfd;
}


int tcp_listen(const char *host, const char *serv, socklen_t *addrlenp) {
  int			listenfd;
  const int		on = 1;
  struct sockaddr_in 	servaddr;


  listenfd = Socket(AF_INET, SOCK_STREAM, 0);
  
  Mzero(&servaddr, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
  servaddr.sin_port = htons(atoi(serv));
  
  Setsockopt(listenfd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on));
   
  Bind(listenfd, (struct sockaddr *)&servaddr, sizeof(servaddr));
  Listen(listenfd, LISTENQ);

  if (addrlenp != NULL) {
    *addrlenp = sizeof(servaddr);	/* return size of protocol address */
  }

  return(listenfd);
}

